package com.maroontress.madangler.client;

import com.google.gwt.core.client.EntryPoint;
import com.google.gwt.user.client.Command;
import com.google.gwt.user.client.DeferredCommand;
import com.google.gwt.user.client.History;
import com.google.gwt.user.client.HistoryListener;
import com.google.gwt.user.client.Window;
import com.google.gwt.user.client.WindowResizeListener;
import com.google.gwt.user.client.ui.HTML;
import com.google.gwt.user.client.ui.RootPanel;
import com.google.gwt.user.client.ui.SimplePanel;
import com.google.gwt.user.client.ui.VerticalPanel;
import com.google.gwt.user.client.ui.Widget;

/**
   ư饹Ǥ

   onModuleLoad()ƤӽФơץꥱ󤬳Ϥޤ
*/
public class MadAngler implements EntryPoint, HistoryListener,
		       WindowResizeListener {

    /** Ǿ̥ѥͥΥڡ */
    public static final int SPACING = 4;

    /** 󥰥ȥΥץꥱΥ󥹥 */
    private static MadAngler theInstance;

    /** ӥɰɽ륵֥ѥͥ */
    private BuildListPanel buildListPanel;

    /** ӥɥɽ륵֥ѥͥ */
    private BuildLogPanel logPanel;

    /** ɽ줿ȤŤ륪С쥤 */
    private HTML overlay;

    /** ʥӥ󥯤ɽѥͥ */
    private NavigationPanel naviPanel;

    /** ץȤ륵֥ѥͥ */
    private NewProjectPanel newProjectPanel;

    /** ץȤꤹ륵֥ѥͥ */
    private ProjectConfigPanel projectConfigPanel;

    /** ץȰꤹ륵֥ѥͥ */
    private ProjectListPanel projectListPanel;

    /** ֥ѥͥοƤȤʤѥͥ */
    private SimplePanel sp;

    /** ץꥱ󥿥ȥȥǥɽѥͥ */
    private TitlePanel titlePanel;

    /** ץꥱκǾ̥ѥͥ */
    private VerticalPanel vp;

    /**
       ȥݥȤǤ
    */
    public void onModuleLoad() {
	theInstance = this;
	titlePanel = new TitlePanel();
	naviPanel = new NavigationPanel();
	RootPanel root = RootPanel.get();
	vp = new VerticalPanel();
	sp = new SimplePanel();

	buildListPanel = new BuildListPanel();
	buildListPanel.setSubPanelListener(new SubPanelListener() {
	    public void canceled(final SubPanel panel) {
		naviPanel.pop();
	    }
	    public void submitted(final SubPanel panel,
				  final String s1, final String s2) {
	    }
	});

	newProjectPanel = new NewProjectPanel();
	newProjectPanel.setSubPanelListener(new SubPanelListener() {
	    public void canceled(final SubPanel panel) {
		naviPanel.pop();
	    }
	    public void submitted(final SubPanel panel,
				  final String id, final String tmpl) {
		MadAngler.alert(id + ": Successfully created");
		projectListPanel.loadProjects();
		Navigation navi = projectConfigPanel.getNavigation();
		Link link = navi.getLink();
		link.addParameter("id", id);
		link.addParameter("template", tmpl);
		naviPanel.replace(navi);
	    }
	});

	projectConfigPanel = new ProjectConfigPanel();
	projectConfigPanel.setSubPanelListener(new SubPanelListener() {
	    public void canceled(final SubPanel panel) {
		naviPanel.pop();
	    }
	    public void submitted(final SubPanel panel,
				  final String s1, final String s2) {
		MadAngler.alert("Changes are successfully saved.");
		projectListPanel.loadProjects();
		naviPanel.pop();
	    }
	});

	projectListPanel = new ProjectListPanel();
	projectListPanel.loadProjects();

	logPanel = new BuildLogPanel();

	overlay
	    = new HTML("<img class=\"overlay\" src=\"images/black.png\"/>");
	overlay.setVisible(false);

	vp.add(overlay);
	vp.add(titlePanel);
	vp.add(naviPanel);
	vp.add(new HTML("&nbsp;"));
	vp.add(sp);
	vp.setSpacing(SPACING);
	root.add(vp);

	Window.setMargin("0px");
	Window.enableScrolling(false);

	parseInitialHistory(History.getToken());
	History.addHistoryListener(this);

        Window.addWindowResizeListener(this);
	resizeAll();
	onWindowResized(Window.getClientWidth(), Window.getClientHeight());
    }

    /**
       󥯤ꤷƥ֥ѥͥꤷޤ

       ֥ѥͥΥ󥯤linkǾ񤭤ޤ

       @param subPanel ֥ѥͥ
       @param link 
    */
    private void setSubPanel(final SubPanel subPanel, final Link link) {
	subPanel.setLink(link);
	setSubPanel(subPanel);
    }

    /**
       ֥ѥͥꤷޤ

       @param subPanel ֥ѥͥ
    */
    private void setSubPanel(final SubPanel subPanel) {
	naviPanel.push(subPanel.getNavigation());
	naviPanel.setNavigationListener(subPanel);
	sp.setWidget(subPanel);
    }

    /**
       ҥȥ˽äƥ֥ѥͥڤؤޤ

       @param token ҥȥΥȡ
    */
    public void parseInitialHistory(final String token) {
	Link el;
	naviPanel.push(projectListPanel.getNavigation());
	if (token == null || (el = Link.decode(token)) == null) {
	    sp.setWidget(projectListPanel);
	    return;
	}
	String type = el.getParameter("type");
	if (type.equals("buildLog")) {
	    Navigation navi = buildListPanel.getNavigation();
	    Link link = navi.getLink();
	    link.addParameter("id", el.getParameter("id"));
	    link.addParameter("serial", el.getParameter("serial"));
	    link.addParameter("platformCode", el.getParameter("platformCode"));
	    link.addParameter("tail", el.getParameter("tail"));
	    naviPanel.push(navi);
	    setSubPanel(logPanel, el);
	} else if (type.equals("buildList")) {
	    setSubPanel(buildListPanel, el);
	} else if (type.equals("config")) {
	    setSubPanel(projectConfigPanel, el);
	} else if (type.equals("newProject")) {
	    setSubPanel(newProjectPanel, el);
	} else {
	    sp.setWidget(projectListPanel);
	}
    }

    /**
       ҥȥ꤬ѲȤ˸ƤӽФޤ

       @param token ҥȥΥȡ
    */
    public void onHistoryChanged(final String token) {
	naviPanel.clearNavigation();
	parseInitialHistory(token);
    }

    /**
       ɥѲȤ˸ƤӽФޤ

       @param width ɥ
       @param height ɥι⤵
    */
    public void onWindowResized(final int width, final int height) {
	projectConfigPanel.adjustSize(width, height);
	buildListPanel.adjustSize(width, height);
	logPanel.adjustSize(width, height);
	sp.setPixelSize(width - 2 * sp.getAbsoluteLeft(),
			height - (sp.getAbsoluteTop() + SPACING));
	vp.setPixelSize(width, height);
    }

    /**
       ɥǽưŪ˹ޤ
    */
    private void resizeAll() {
	DeferredCommand.addCommand(new Command() {
	    public void execute() {
		onWindowResized(Window.getClientWidth(),
				Window.getClientHeight());
	    }
	});
    }

    /**
       ץꥱΥ󥹥󥹤ޤ

       @return ץꥱΥ󥹥
    */
    private static MadAngler getInstance() {
	return theInstance;
    }

    /**
       ץꥱǽưŪ˥ꥵޤ
    */
    public static void resize() {
	theInstance.resizeAll();
    }

    /**
       ǥ󥰥ǥꤷޤ

       @param b ɽtrueǤʤfalse
    */
    public static void setLoading(final boolean b) {
	theInstance.titlePanel.setLoading(b);
    }

    /**
       С쥤ɽɽꤷޤ

       @param b С쥤ɽtrueǤʤfalse
    */
    public static void setOverlay(final boolean b) {
	theInstance.overlay.setVisible(b);
    }

    /**
       ˥åɽޤ

       ɽϥС쥤ɽޤ

       @param m å
    */
    public static void alert(final String m) {
	theInstance.overlay.setVisible(true);
	Window.alert(m);
	theInstance.overlay.setVisible(false);
    }

    /**
       ˥åɽơOk/Cancel򤷤ޤ

       ɽϥС쥤ɽޤ

       @param m å
       @return OKξfalseCancelξtrue
    */
    public static boolean confirm(final String m) {
	theInstance.overlay.setVisible(true);
	boolean b = Window.confirm(m);
	theInstance.overlay.setVisible(false);
	return b;
    }

    /**
       ǥ˥ƥȤꤷޤ

       ǥХåѤǤ

       @param s ɽƥ
    */
    public static void setText(final String s) {
	theInstance.titlePanel.setText(s);
    }

    /**
       åȤΥʸǼޤ

       ǥХåѤǤ

       @param w å
       @return ɽʸx⤵+Xɸ+Yɸ
    */
    public static String getGeometry(final Widget w) {
	return w.getOffsetWidth() + "x" + w.getOffsetHeight()
	    + "+" + w.getAbsoluteLeft() + "+" + w.getAbsoluteTop();
    }
}
