package com.maroontress.madangler.client.config;

import com.google.gwt.xml.client.Attr;
import com.google.gwt.xml.client.Document;
import com.google.gwt.xml.client.Element;
import com.google.gwt.xml.client.NamedNodeMap;
import com.google.gwt.xml.client.XMLParser;
import java.util.ArrayList;
import java.util.HashMap;

/**
   ץΥǥǤ
*/
public class ConfigModel {

    /** ץѥƥΥޥå */
    private HashMap<String, String> propertyMap;

    /** ץåȥեΥޥå */
    private ArrayList<Platform> platformSet;

    /** ѹΤꥹʤΥꥹ */
    private ArrayList<ChangedListener> listenerSet;

    /**
       Υץޤ
    */
    public ConfigModel() {
	propertyMap = new HashMap<String, String>();
	platformSet = new ArrayList<Platform>();
	listenerSet = new ArrayList<ChangedListener>();
    }

    /**
       ѹΤꥹʤɲäޤ

       @param listener ѹΤꥹ
    */
    public void addChangedListener(final ChangedListener listener) {
	listenerSet.add(listener);
    }

    /**
       ٤ƤΥꥹʤѹΤޤ
    */
    public void notifyChanged() {
	for (int k = 0; k < listenerSet.size(); ++k) {
            ChangedListener listener = listenerSet.get(k);
            listener.propertyChanged(this);
        }
    }

    /**
       ץѥƥͤޤ

       @param name ץѥƥ̾
       @return ץѥƥ
    */
    public String getProperty(final String name) {
	String s = propertyMap.get(name);
	return (s == null) ? "" : s;
    }

    /**
       ץåȥեͤޤ

       @param k ץåȥեΥǥå
       @return ץåȥե
    */
    public Platform getPlatform(final int k) {
	return platformSet.get(k);
    }

    /**
       IDꤷƥץåȥեͤޤ

       @param id ץåȥեID
       @return ץåȥե
    */
    public Platform getPlatformById(final String id) {
	int n = platformSet.size();
	for (int k = 0; k < n; ++k) {
	    Platform p = platformSet.get(k);
	    if (p.getId().equals(id)) {
		return p;
	    }
	}
	return null;
    }

    /**
       ץåȥեθĿޤ

       @return ץåȥեθĿ
    */
    public int getPlatformSize() {
	return platformSet.size();
    }

    /**
       ץѥƥͤꤷޤ

       @param name ץѥƥ̾
       @param value ץѥƥ
    */
    public void setProperty(final String name, final String value) {
	propertyMap.put(name, value);
    }

    /**
       ץåȥեͤɲäޤ

       @param platform ץåȥե
    */
    public void addPlatform(final Platform platform) {
	platformSet.add(platform);
    }

    /**
       ץåȥեͤޤ

       @param k ץåȥեΥǥå
    */
    public void removePlatform(final int k) {
	platformSet.remove(k);
    }

    /**
       ץåȥեͤѹޤ

       @param k ץåȥեΥǥå
       @param platform ץåȥե
    */
    public void setPlatform(final int k, final Platform platform) {
	platformSet.set(k, platform);
    }

    /**
       ˤޤ
    */
    public void clear() {
	propertyMap.clear();
	platformSet.clear();
    }

    /**
       ץѥƥpropertyǤꤷޤ

       @param elem 
    */
    public void setPropertyElement(final Element elem) {
	NamedNodeMap map = elem.getAttributes();
	for (int k = 0; k < map.getLength(); ++k) {
	    Attr attr = (Attr) map.item(k);
	    propertyMap.put(attr.getName(), attr.getValue());
	}
    }

    /**
       ץåȥեplatformǤꤷޤ

       @param elem 
    */
    public void addPlatformElement(final Element elem) {
	platformSet.add(new Platform(elem));
    }

    /**
       ץXMLѴޤ

       @return XMLѴ줿ץ
    */
    public String getXML() {
	Document d = XMLParser.createDocument();
	Element root = d.createElement("projectConfig");
	Element elem;

	elem = d.createElement("property");
	String[] key = propertyMap.keySet().toArray(new String[0]);
	for (int k = 0; k < key.length; ++k) {
	    String name = key[k];
	    String value = getProperty(name);
	    elem.setAttribute(name, value);
	}
	root.appendChild(elem);

	int n = getPlatformSize();
	for (int k = 0; k < n; ++k) {
	    Platform p = getPlatform(k);
	    elem = d.createElement("platform");
	    p.exportAttributes(elem);
	    root.appendChild(elem);
	}

	d.appendChild(root);
	return d.toString();
    }
}
