package com.maroontress.madangler.client.config;

import com.google.gwt.user.client.ui.Button;
import com.google.gwt.user.client.ui.ChangeListener;
import com.google.gwt.user.client.ui.ClickListener;
import com.google.gwt.user.client.ui.DockPanel;
import com.google.gwt.user.client.ui.HTML;
import com.google.gwt.user.client.ui.HorizontalPanel;
import com.google.gwt.user.client.ui.Label;
import com.google.gwt.user.client.ui.ListBox;
import com.google.gwt.user.client.ui.VerticalPanel;
import com.google.gwt.user.client.ui.Widget;
import com.maroontress.madangler.client.MadAngler;
import com.maroontress.madangler.client.ImageButton;
import java.util.ArrayList;

/**
   ץåȥեΥѥͥǤ
*/
public class PlatformsPanel extends DockPanel {

    /** 򤵤줿Ȥͭˤʤܥ */
    private ArrayList<Button> buttonGroup;

    /** ץåȥե˰ưܥ */
    private Button upButton;

    /** ץåȥե򲼤˰ưܥ */
    private Button downButton;

    /** ץΥǥ */
    private ConfigModel model;

    /** ץåȥեʸå̾ */
    private Label charset;

    /** ץåȥեΥ⡼ȥޥ */
    private Label command;

    /** ץåȥեΥ桼@ۥ */
    private Label userAtHost;

    /** ץåȥեIDΰΥꥹȥܥå */
    private ListBox box;

    /** ץåȥեɲå */
    private PlatformDialog dialog;

    /** ץåȥեԽ */
    private PlatformEditor editor;

    /** ץåȥե̾ */
    private PlatformRenamer renamer;

    /** 򤵤줿ץåȥեξɽΥѥͥ */
    private VerticalPanel centerPanel;

    /** Υѥͥ */
    private VerticalPanel westPanel;

    /**
       ץåȥեΥѥͥޤ

       @param model ץΥǥ
    */
    public PlatformsPanel(final ConfigModel model) {
	this.model = model;
	model.addChangedListener(new ChangedListener() {
	    public void propertyChanged(final ConfigModel model) {
		int selected = box.getSelectedIndex();
		box.clear();
		int n = model.getPlatformSize();
		for (int k = 0; k < n; ++k) {
		    Platform p = model.getPlatform(k);
		    box.addItem(p.getId());
		}
		int itemCount = box.getItemCount();
		if (selected != -1) {
		    if (selected >= itemCount) {
			selected = itemCount - 1;
		    }
		    box.setSelectedIndex(selected);
		} else if (itemCount > 0) {
		    box.setSelectedIndex(0);
		}
		changePoster();
	    }
	});

	westPanel = new VerticalPanel();
	centerPanel = new VerticalPanel();
	userAtHost = new Label("");
	command = new Label("");
	charset = new Label("");

	westPanel.add(new HTML("Platform ID"));
	box = new ListBox();
	box.setVisibleItemCount(6);
	box.setWidth("100%");
	box.addChangeListener(new ChangeListener() {
	    public void onChange(final Widget sender) {
		changePoster();
	    }
	});
	westPanel.add(box);

	Button addButton = new Button("Add...");
	addButton.addClickListener(new ClickListener() {
	    public void onClick(final Widget sender) {
		addPlatform();
	    }
	});

	Button removeButton = new Button("Delete");
	removeButton.addClickListener(new ClickListener() {
	    public void onClick(final Widget sender) {
		removePlatform();
	    }
	});

	Button editButton = new Button("Edit...");
	editButton.addClickListener(new ClickListener() {
	    public void onClick(final Widget sender) {
		editPlatform();
	    }
	});

	Button renameButton = new Button("Rename...");
	renameButton.addClickListener(new ClickListener() {
	    public void onClick(final Widget sender) {
		renamePlatform();
	    }
	});

	Button cloneButton = new Button("Clone");
	cloneButton.addClickListener(new ClickListener() {
	    public void onClick(final Widget sender) {
		clonePlatform();
	    }
	});

	upButton = new ImageButton("arrow-up", null);
	upButton.addClickListener(new ClickListener() {
	    public void onClick(final Widget sender) {
		upPlatform();
	    }
	});

	downButton = new ImageButton("arrow-down", null);
	downButton.addClickListener(new ClickListener() {
	    public void onClick(final Widget sender) {
		downPlatform();
	    }
	});

	HorizontalPanel bp = new HorizontalPanel();
	HTML space = new HTML("&nbsp;");
	bp.add(addButton);
	bp.add(removeButton);
	bp.add(editButton);
	bp.add(renameButton);
	bp.add(cloneButton);
	bp.add(upButton);
	bp.add(downButton);
	westPanel.add(bp);

	buttonGroup = new ArrayList<Button>();
	buttonGroup.add(removeButton);
	buttonGroup.add(editButton);
	buttonGroup.add(renameButton);
	buttonGroup.add(cloneButton);
	buttonGroup.add(upButton);
	buttonGroup.add(downButton);

	centerPanel.add(new HTML("&nbsp;"));
	centerPanel.add(new HTML("User@Hostname"));
	centerPanel.add(userAtHost);
	centerPanel.add(new HTML("&nbsp;"));
	centerPanel.add(new HTML("Command"));
	centerPanel.add(command);
	centerPanel.add(new HTML("&nbsp;"));
	centerPanel.add(new HTML("Charset"));
	centerPanel.add(charset);

	add(westPanel, DockPanel.WEST);
	add(new HTML("&nbsp;"), DockPanel.CENTER);
	add(centerPanel, DockPanel.EAST);
	setCellWidth(centerPanel, "100%");

	changePoster();

	dialog = new PlatformDialog(model);
	editor = new PlatformEditor(model);
	renamer = new PlatformRenamer(model);
    }

    /**
       ץåȥե֤ꥻåȤޤ
    */
    public void reset() {
	box.setSelectedIndex(-1);
    }

    /**
       ץåȥեɽ򹹿ޤ
    */
    private void changePoster() {
	int i = box.getSelectedIndex();
	boolean b = (i != -1);
	int n = buttonGroup.size();
	for (int k = 0; k < n; ++k) {
	    Button button = buttonGroup.get(k);
	    button.setEnabled(b);
	}
	centerPanel.setVisible(b);
	if (i < 0) {
 	    return;
	}
	if (i == 0) {
	    upButton.setEnabled(false);
	}
	if (i == box.getItemCount() - 1) {
	    downButton.setEnabled(false);
	}
	Platform p = model.getPlatform(i);
	userAtHost.setText(p.getHost());
	command.setText(p.getCommand());
	charset.setText(p.getCharset());
    }

    /**
       ץåȥեɲäޤ
    */
    private void addPlatform() {
	dialog.center();
    }

    /**
       ץåȥեޤ
    */
    private void removePlatform() {
	int i = box.getSelectedIndex();
	if (i < 0) {
	    return;
	}
	if (!MadAngler.confirm("You are about to delete the platform \""
			       + model.getPlatform(i).getId()
			       + "\". Are you sure you want to continue?")) {
	    return;
	}
	model.removePlatform(i);
	model.notifyChanged();
    }

    /**
       ץåȥեԽޤ
    */
    private void editPlatform() {
	int i = box.getSelectedIndex();
	if (i < 0) {
	    return;
	}
	editor.setPlatformIndex(i);
	editor.center();
    }

    /**
       ץåȥեIDѹޤ
    */
    private void renamePlatform() {
	int i = box.getSelectedIndex();
	if (i < 0) {
	    return;
	}
	renamer.setPlatformIndex(i);
	renamer.center();
    }

    /**
       ץåȥե촹ޤ

       iܤΥץåȥեjܤΥץåȥե촹
       ȡjܤΥץåȥեब򤵤줿֤ˤʤޤ

       @param i ץåȥեΥǥå
       @param j ץåȥեΥǥå
    */
    private void exchangePlatform(final int i, final int j) {
	Platform p1 = model.getPlatform(j);
	Platform p2 = model.getPlatform(i);
	model.setPlatform(j, p2);
	model.setPlatform(i, p1);
	model.notifyChanged();
	box.setSelectedIndex(j);
	changePoster();
    }

    /**
       ץåȥե˰ưޤ
    */
    private void upPlatform() {
	int i = box.getSelectedIndex();
	int j = i - 1;
	if (i < 0 || j < 0) {
	    return;
	}
	exchangePlatform(i, j);
    }

    /**
       ץåȥե򲼤˰ưޤ
    */
    private void downPlatform() {
	int i = box.getSelectedIndex();
	int j = i + 1;
	int n = model.getPlatformSize();
	if (i < 0 || j == n) {
	    return;
	}
	exchangePlatform(i, j);
    }

    /**
       ץåȥեʣޤ

       ץåȥեID "X" ξ "Copy of X" Ȥץåȥե
       IDɲäޤ"Copy of X" Ǥ¸ߤ "Copy of X
       (n)" Ȥǿ "n" ղäޤ
    */
    private void clonePlatform() {
	int i = box.getSelectedIndex();
	if (i < 0) {
	    return;
	}
	Platform orig = model.getPlatform(i);
	String id = "Copy of " + orig.getId();
	String host = orig.getHost();
	String command = orig.getCommand();
	String charset = orig.getCharset();
	for (int k = 2; model.getPlatformById(id) != null; ++k) {
	    id = "Copy of " + orig.getId() + "(" + k + ")";
	}
	model.addPlatform(new Platform(id, host, command, charset));
	model.notifyChanged();
    }
}
