#ifndef Builder_H
#define Builder_H

#define Builder_UNKNOWN 0
#define Builder_SUCCESS 1
#define Builder_FAIL 2

struct Builder;
struct BoxKit;
struct Environment;

struct Builder * Builder_create(struct BoxKit *kit, const char *revision,
				const char *author);
void Builder_free(struct Builder *b);
int Builder_run(struct Builder *b, struct Environment *e);
int Builder_getLoad(struct Builder *b);
int Builder_findPrevious(struct Builder *b);
int Builder_setSerial(struct Builder *b, int serial);
struct Serial * Builder_getSerial(struct Builder *b);
char * Builder_getProjectID(struct Builder *b);
char * Builder_getLastRevision(struct Builder *b);
char * Builder_getLogDir(struct Builder *b);
int Builder_getMailEnabled(struct Builder *b);

#endif
